/******************************************************************************
*                                                                             *
*   TheTrap 0.1beta                                                           *
*                                                                             *
*   by Frank Adaemmer  copyrights[at]gmx.de                                   *
*                                                                             *
*   Source Code                                                               *
*                                                                             *
*   File:   hook.c                                                            *
*   Use:    - source code file                                                *
*           - main routine of the hook                                        *
*                                                                             *
*******************************************************************************

TheTrap - A utility for TI's 68k calculaters

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

//Original code from: Sample TSR by Greg Dietsche - Last Modification: 10/22/2002
//Modified by: Thomas Naeff, 16.03.2006


//-----------------------------------------------------------------------------
// Undocumented macro in TIGCC v0.95 and above: Do not create global imports
// for startup code. This macro is defined exclusively for ttstart; do not use
// it in your own programs. In ttstart, it only suppresses a lot of warnings.
//-----------------------------------------------------------------------------
#define _NO_INCLUDE_PATCH

//TODO: Set Your Event Hook's Name
//Hook Name: Must Be 8 non-zero characters! Use Spaces if necessary to fill this requirement
//You should edit this to reflect the name of your event hook...
//When uninstalling your event hook, the uninstall program will use this name in its list of
//installed TSR Event Hooks
	#define TSR_NAME "TheTrap "
//Usually this results in smaller code, OPTIMIZE_ROM_CALLS also makes calling rom functions faster
//than they would be normally
//#define OPTIMIZE_ROM_CALLS

//TODO: Do you need to have TIGCC detect the calc type?
//For Sample TSR, defining NO_CALC_DETECT will result in smaller code
//You should comment this out to see if smaller code is produced in your own projects...
//Often times, undefining (commenting out) NO_CALC_DETECT will result in
//smaller code if you use the so-called psuedo constants such as KEY_UP in compat.h
	#define NO_CALC_DETECT
	#define MIN_AMS 207

//TODO: Select the calculators that you are compiling for...
//In the project otions, maybe you should uncheck all checkmarks at
//Project -> Options... -> Compilation -> Calculator
//(If these project options are available in your version of TIGCC)
	#define USE_TI89
	#define USE_TI92PLUS
	#define USE_V200

//Necessary Header Files
	#include <tigcclib.h>

//Functions
	TEXT_EDIT *TE_findHomeScreen(void);
	void smk(void);
	short CallBack( short dlgId, long Value );
	void smk(void);
	void memmenue(void);
	void HomeScreenRestore(void);
	void Install_TSR(void);
	void EventHandler(EVENT *ev);
	void verstecken(short hd);
	void RunCmd(char *SimpleCommand);
	//void zeigen(char *name);

//This Code needs TIGCC 0.94 beta 19 at the very least to function properly
//Thomas: I set this to TIGCC 0.96 beta 6 because I tested it with this version.
#if __TIGCC__== 0 && __TIGCC_MINOR__< 96 && __TIGCC_BETA__ < 6
	#warning Sample TSR - Old TIGCC Version -- Check tigcc.ticalc.org for updates
#endif

//constants for hook
#define SND_SIX 4150
#define SND_MINUS 4141
//#define DIA_ENTER 8205
#define DIA_B 8258
#define DIA_A 8257

#define MWIDTH 228
#define MHEIGHT 113
#define MTOP 8


#define LHEIGHT 8
#define MLISTTOP 31
#define MFC 7
#define MSC 103
#define MTC 121
#define MFOC 211

#define ItemHeight 10

#define O_ALLMEMORY 4
#define O_ALLRAM 5
#define O_DEFAULT 6
#define O_ARCHIVE 7
#define O_FLASHAPPS 8
#define O_BOTH 9

//Global Variables Go Here
extern EVENT_HANDLER gpOldHandler; 		//a pointer to a pointer to the old handler
BOOL trapActiv = TRUE;
unsigned short killOpt;
enum Items {Scroll_ID,Title_ID,Toolbar_ID,HPopup1_ID,Edit_ID,DPopup1_ID,DEdit_ID,DPopup2_ID,HPopup2_ID,Radio_ID,Exit_ID,OwnerDrawn_ID,Text_ID,XFlags_ID};



// ---------------------------[ CallBack ]-------------------------- //
// Callback function for the simulate MemoryMenue                    //
// ----------------------------------------------------------------- //
short CallBack( short dlgId, long Value )
{
   unsigned short HitKey, key;
   HANDLE MenuHandle = H_NULL;
   MenuHandle = HI_WORD(Value);
   HitKey = LO_WORD(Value);
   int   result = -2;
   switch( HitKey )
   {
   		case KEY_F1:
      	while (result == -2)
        {
        	result = MenuKey (MenuHandle, HitKey);
        }
				switch(result)
        {
           case O_ALLMEMORY: //All Memory
           	key = DlgMessage("RESET", "Resetting All will delete\nall data, programs, and\nFlash applications form RAM\nand Flash ROM", BT_OK, BT_CANCEL );
           	break;
           case O_ALLRAM: //All RAM
           	key = DlgMessage("RESET", "Resetting RAM erases all\ndata and progams from RAM", BT_OK, BT_CANCEL );
           	break;
           case O_DEFAULT: //Default
           	key = DlgMessage("RESET", "Reset Default restores all\nsystem variables and modes\nto their original factory\nsettings", BT_OK, BT_CANCEL );
           	break;
           case O_ARCHIVE: //Archive
           	key = DlgMessage("RESET", "Resetting Archive erases all\ndata and progams from Flash\nROM", BT_OK, BT_CANCEL );
           	break;
           case O_FLASHAPPS: //Flash Apps
           	key = DlgMessage("RESET", "Resetting Flash Apps erases\nall Flash applications from\nFlash ROM", BT_OK, BT_CANCEL );
           	break;
           case O_BOTH: //Both
           	key = DlgMessage("RESET", "Resetting Both erases all\ndata, progams, and Flash\napplications from Flash ROM", BT_OK, BT_CANCEL );
           	break;
           default:
           	key=KEY_ESC; 
           	break;
         }
         if(key==KEY_ESC)
         return 0;
         else {
         	killOpt = result;
         	return DB_EXIT;
         }
                 
       default:
         return 1;
         break;
   }
}








// ----------------------------[ smk ]------------------------------ //
// Simulate Memory Kill                                              //
// ----------------------------------------------------------------- //
void smk(void){
	short pulldown_buffer[4];
	//char* ptr;
	unsigned short dlg_ret_val = 0;
	
	short i;
	static HANDLE feins;
	HANDLE dlg;
	
	// new dialog
	if ((dlg = DialogNew(MWIDTH, MHEIGHT, CallBack)) == H_NULL)
	{
		goto error;
	}

	if((feins=MenuNew(0,0,0))){
		MenuAddText( feins, 0, "RESET", 1, DMF_TOP );
		MenuAddText( feins, 1, "RAM", 2, DMF_CHILD_SUB );
		MenuAddText( feins, 1, "Flash ROM", 3, DMF_CHILD_SUB );
		MenuAddText( feins, 1, "All Memory", O_ALLMEMORY, DMF_CHILD_SUB );
		MenuAddText( feins, 2, "All RAM", O_ALLRAM, DMF_CHILD_SUB );
		MenuAddText( feins, 2, "Default", O_DEFAULT, DMF_CHILD_SUB );
		MenuAddText( feins, 3, "Archive", O_ARCHIVE, DMF_CHILD_SUB );
		MenuAddText( feins, 3, "Flash Apps", O_FLASHAPPS, DMF_CHILD_SUB );
		MenuAddText( feins, 3, "Both", O_BOTH, DMF_CHILD_SUB );
	}else goto error;
	
	DialogAddTitle(dlg, "MEMORY",  BT_OK, BT_NONE); 
	DialogAddMenu(dlg,0,19,12,HLock(feins), 60);

	DialogAddTextEx( dlg, 0, MFC, (MLISTTOP+LHEIGHT*0), "Expr");
	DialogAddTextEx( dlg, 0, MFC, (MLISTTOP+LHEIGHT*1), "List");
	DialogAddTextEx( dlg, 0, MFC, MLISTTOP+LHEIGHT*2, "Matrix");
	DialogAddTextEx( dlg, 0, MFC, MLISTTOP+LHEIGHT*3, "Function");
	DialogAddTextEx( dlg, 0, MFC, MLISTTOP+LHEIGHT*4, "Prgm/Asm");
	DialogAddTextEx( dlg, 0, MFC, MLISTTOP+LHEIGHT*5, "Picture");
	DialogAddTextEx( dlg, 0, MFC, MLISTTOP+LHEIGHT*6, "String");
	
	for(i=0;i<7;i++){
		DialogAddTextEx( dlg, 0, MSC, MLISTTOP+LHEIGHT*i, "0");
		DialogAddTextEx( dlg, 0, MFOC, MLISTTOP+LHEIGHT*i, "0");
	}
	DialogAddTextEx( dlg, 0, MFOC, MLISTTOP-LHEIGHT, "0");
	DialogAddTextEx( dlg, 0, 187, MLISTTOP+LHEIGHT*4, "70598");
	
	DialogAddTextEx( dlg, 0, MTC, (MLISTTOP+LHEIGHT*-1), "Text");
	DialogAddTextEx( dlg, 0, MTC, (MLISTTOP+LHEIGHT*0), "GDB");
	DialogAddTextEx( dlg, 0, MTC, (MLISTTOP+LHEIGHT*1), "Data");
	DialogAddTextEx( dlg, 0, MTC, MLISTTOP+LHEIGHT*2, "Other");
	DialogAddTextEx( dlg, 0, MTC, MLISTTOP+LHEIGHT*3, "History");
	DialogAddTextEx( dlg, 0, MTC, MLISTTOP+LHEIGHT*4, "System");
	DialogAddTextEx( dlg, 0, MTC, MLISTTOP+LHEIGHT*5, "FlashApp");
	DialogAddTextEx( dlg, 0, MTC, MLISTTOP+LHEIGHT*6, "Archive");
	
	DialogAddTextEx( dlg, 0, 85, 90, "RAM free");
	DialogAddTextEx( dlg, 0, 181, 90, "191546");
	DialogAddTextEx( dlg, 0, 85, 90+LHEIGHT, "Flash ROM free");
	DialogAddTextEx( dlg, 0, 175, 90+LHEIGHT, "2818018");
	
	
	if ((dlg_ret_val = DialogDo(dlg, CENTER, MTOP, NULL, pulldown_buffer)) == KEY_ENTER){
		//dummy
		i = 1;
	}
	
	error:
	HeapFree(dlg);
	HeapUnlock(feins);
	HeapFree(feins);
}

// ---------------------------[ memmenue ]-------------------------- //
// Runs the simulate MemoryMenue and parse options                   //
// ----------------------------------------------------------------- //
void memmenue(void)
{
	killOpt=0;
	smk();
	switch(killOpt){
		case 0:
			break;
		case O_ALLMEMORY:
			RunCmd("ClockOn:setTime(0,0,0):setDate(1997,1,1)");
			cmd_clrhome();
		  cmd_clrdraw();
			cmd_clrerr();
			cmd_clrgraph();
			TEXT_EDIT * entryLine = TE_findHomeScreen();
			TE_empty(entryLine);
	  	OSFreeTimer (USER_TIMER);
			OSRegisterTimer (USER_TIMER, 3.5*20);
			HomeScreenRestore();
			clrscr ();
			while (!OSTimerExpired (USER_TIMER));
			verstecken(1);
			pushkey(KEY_APPS);
			HomeScreenRestore();
			break;
		case O_ALLRAM:
			DlgMessage("RESET", "RAM reset", BT_OK, BT_NONE );
			
			break;
		case O_DEFAULT:
			clrscr ();
			DlgMessage("RESET", "Default set", BT_OK, BT_NONE );
			pushkey(KEY_APPS);
			break;
		case O_ARCHIVE:
			DlgMessage("RESET", "Flash ROM Archive reset", BT_OK, BT_NONE );
			break;
		case O_FLASHAPPS:
			DlgMessage("RESET", "Flash ROM Applications reset", BT_OK, BT_NONE );
			break;
		case O_BOTH:
			DlgMessage("RESET", "Flash ROM Archive and\nApplications reset", BT_OK, BT_NONE );
			break;
		default:
			break;		
	}
}


//thanks to Samuel Stearley for explaining how his tsr hook, complete,
//gets the pointer to the home screen text edit structure in an ams
//independent manner. I (Greg) have taken his code and ported it to C.
TEXT_EDIT *TE_findHomeScreen(void)
{
register void *a=HomeExecute;

while(*(unsigned long*)a!=(unsigned long)TE_select)
a+=2;

return (TEXT_EDIT*)(unsigned long)(*(unsigned short*)(a-4));
}



void HomeScreenRestore(void);//from HSR v3.0 [(c) Greg Dietsche] 
asm("HomeScreenRestore:\n"\
"     movem.l  %d0-%d7/%a0-%a6,-(%a7)\n"\
"     movea.l  0xC8,%a4\n"\
"     movea.l  (0x124,%a4),%a0\n"\
"     jsr      (%a0)               | call MenuUpdate\n"\
"     move.w   #0xA,-(%a7)\n"\
"     movea.l  (0x3AC,%a4),%a0\n"\
"     jsr      (%a0)               | call ST_refDsp with empty message\n"\
"     movea.l  (0x38C,%a4),%a0\n"\
"     jsr      (%a0)               | call ST_eraseHelp\n"\
"     move.l   #0x1E,-(%a7)\n"\
"     move.w   #0xFF,-(%a7)\n"\
"     move.l   %a4,%d0\n"\
"     andi.l   #0x400000,%d0\n"\
"     bne.s    ____no_ti89         | TI92p\n"\
"     movea.l  (0xBC,%a4),%a0\n"\
"     cmpi.b   #0xEF,(0x2,%a0)\n"\
"     beq.s    ____no_ti89         | V200\n"\
"     pea      0x56E6\n"\
"     bra.s    ____drawline\n"\
"____no_ti89:\n"\
"     pea      0x5A2E\n"\
"____drawline:\n"\
"    movea.l  (0x9F0,%a4),%a0\n"\
"    jsr      (%a0)                | call memset (draws bottom line)\n"\
"    movea.l  (%a4),%a0            | FirstWindow\n"\
"    movea.l  (%a0),%a0            | dereference the pointer\n"\
"____dirtywindows:\n"\
"    ori.w    #0x2000,(%a0)        | set Dirty Flag\n"\
"    tst.l    (0x22,%a0)           | is there another window?\n"\
"    movea.l  (0x22,%a0),%a0       | movea does not affect ccr\n"\
"    bne.s    ____dirtywindows\n"\
"    lea      (0xC,%a7),%a7\n"\
"    movem.l  (%a7)+,%d0-%d7/%a0-%a6\n"\
"    rts");





///////////////////////
// EV_hook Header		//
/////////////////////
//The Total Length of this header is 22 bytes
//The Offset to jmp Install_TSR:l is 16 bytes
//The Offset to gpOldHandler is 12 bytes
//Here is now the patch for TIGCC 0.94 from Kevin Kovler (added by Thomas Naeff)
asm(".section _stl1 | First library startup section. This is what the executable starts with.
		.ascii \"evHk" TSR_NAME "\"
		.globl gpOldHandler
		gpOldHandler:
		.long 0
		__jmp__Event_Hook__:
		jmp Install_TSR:l

		.global __calculator
		__calculator:
		.word 0");

	//Final offset: 22 bytes
///////////////////////////////
// End of EV_hook Header		//
/////////////////////////////







//Install Function -  this function will be executed ONCE, and ONLY ONCE
void Install_TSR(void)
{
		extern char __jmp__Event_Hook__;
		char *ptr=&__jmp__Event_Hook__;

	//Set EventHandler as the default entry point from now on
	//instead of Install_TSR (this function)
		*(unsigned long*)&ptr[2]=(unsigned long)EventHandler;

	#ifndef NO_CALC_DETECT
		asm volatile("
		/* Start Of Calculator Detection Code -- From TIGCC Sources */
				move.l 0xC8,%%a0
				/* Calculator Detection */
				moveq #1,%%d0
				move.l %%a0,%%d1
				and.l #0x400000,%%d1
				jbne __calc_in_d0__
				clr.w %%d0
				move.l (%%a0,0x2F*4),%%a1 /* ScrRect */
				cmp.b #200,2(%%a1)
				jbcs __calc_in_d0__
				moveq #3,%%d0
			__calc_in_d0__:
				lea __calculator(%%pc),%%a1
				move.w %%d0,(%%a1)
		/* End Of Calculator Detection Code -- From TIGCC Sources */"
		:
		:
		: "a0", "a1", "d1");
	#endif

		//TODO: Add any one time initialization code here
		//Warning, what ever you write here must be absolutely
		//crash/error proof!!
}

void EventHandler(EVENT *ev)
{
//////////////////////////////////////////////
//Prepatory Setup for the Event Handler    //
////////////////////////////////////////////

// a special variable: pointer to a function
	EVENT_HANDLER OldHook;
	
	#ifdef OPTIMIZE_ROM_CALLS
		void *__saved_a5__;//a variable to save the register a5 so it can be restored later
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %%a5,%0":"=p"(__saved_a5__));
		asm("move.l 0xC8,%a5");
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

/////////////////////////////////////////////////////////////////


	if(ev->Type==CM_KEYPRESS)
	{
		  //get 2nd+6
			if(trapActiv && ev->extra.Key.Code==SND_SIX)
			{
				ev->extra.Key.Code=KEY_ESC;	//send ESC (don't if needed)

				//simulate memory menu
				memmenue();

			}
			//Daimond + a activate/deactivate TheTrap
			if(ev->extra.Key.Code==DIA_A) {
				
				if(trapActiv){
					trapActiv=FALSE;
					verstecken(0);
					ST_showHelp(TSR_NAME"deactivated. VarLink visible");
				}
				else{
					trapActiv=TRUE;
					ST_showHelp(TSR_NAME"activated.");
				} 
				
			}
			//hide varlink on 2nd + -
			if(trapActiv && ev->extra.Key.Code==SND_MINUS) {
				ev->extra.Key.Code=KEY_ESC;	//send ESC (don't if needed)
				verstecken(1);
				ev->extra.Key.Code=SND_MINUS;
			}
			if(ev->extra.Key.Code==DIA_B){
				cmd_clrhome();
			  cmd_clrdraw();
				cmd_clrerr();
				cmd_clrgraph();
				TEXT_EDIT * entryLine = TE_findHomeScreen();
				TE_empty(entryLine);
				trapActiv=TRUE;
			}
	}


///////////////////////////////////////
//Call the Old hook if there was one//
/////////////////////////////////////

//get the address of the next TSR in line to be executed NULL if there is none
  OldHook=gpOldHandler;

//Call the old hook if there is one to be called
  if(OldHook)
  {
  	asm("								/*This inline asm takes the place of OldHook(ev);
  												the difference is that a2 will also contain ev
  												as a parameter to support TEOS. Without this code,
  												you would need to use the switch -ffixed a2 when
  												compiling this example.*/
  	move.l %0,%%a2			/*TEOS expects the parameter to be in a2*/
  	move.l %%a2,-(%%sp)	/*other event hooks expect it on the stack*/
  	move.l %1,%%a0			/*Get the address to call*/
  	jsr (%%a0)					/*Call the next event hook*/
  	addq.l #4,%%sp			/*restore the stack*/
  	"::"p"(ev),"g"(OldHook):"a0","a2");
  }//end if(OldHook)

	#ifdef OPTIMIZE_ROM_CALLS
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %0, %%a5	/*support for OPTIMIZE_ROM_CALLS*/"::"p"(__saved_a5__));
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

}


// --------------------------[ verstecken ]------------------------- //
// hide/unhide all var-link files                                    //
// ----------------------------------------------------------------- //
void verstecken(short hd)
{
	SYM_ENTRY *SymPtr;
	char name[9];

	SymPtr = SymFindFirst(NULL, FO_RECURSE);
	for ( ;SymPtr != NULL; SymPtr = SymFindNext())
	{
		strcpy(name,SymPtr->name);
		if(strcmp(name,"main")!=0)
		SymPtr->flags.bits.hidden=hd;
	}		
}

/*
// --------------------------[ zeigen ]----------------------------- //
// unhide a single file                                              //
// ----------------------------------------------------------------- //
void zeigen(char *name){
	SYM_ENTRY *SymPtr;
	SymPtr = SymFindFirst(NULL, FO_RECURSE);
	for ( ;SymPtr != NULL; SymPtr = SymFindNext())
	{
		if (strcmp (SymPtr->name, name)==0) SymPtr->flags.bits.hidden=0;
	}
}
*/

void RunCmd(char *SimpleCommand)
{
	HANDLE CommandHandle; // handle of the command
	ESI *TopEstackPtr;    // estack pointer
	ESI TopEstackBckp;  // estack backup
	
	TopEstackPtr = &top_estack;
	TopEstackBckp = *TopEstackPtr;
	
	// push it to the estack
	push_parse_text(SimpleCommand);
	
	// we cannot use HS_popEStack() in a TSR, because it would pop ALL the estack !
	// (even what the AMS has pushed before).(Thank you Kevin Kofler for having
	// fixed this)
	// so we are using Samuel Stearley's trick : we copy just what has been added
	// to the stack in a block of memory.
	{
		unsigned short ParsedDataSize = *TopEstackPtr - TopEstackBckp;
		unsigned short *NewBlockPtr;
		
		// + 2 for the size at the beginning of the block
		if (!(CommandHandle = HeapAllocHigh (ParsedDataSize + 2))) {
			ST_helpMsg ("Not enough memory.");
			return;
		}
		NewBlockPtr = HeapDeref (CommandHandle);
		// NG_execute needs this
		*NewBlockPtr++ = ParsedDataSize;
		// TopEstackBackup + 1 points to the parsed data
		memcpy (NewBlockPtr, TopEstackBckp + 1, ParsedDataSize);
		*TopEstackPtr = TopEstackBckp;     // restore the top_estack pointer
	}

	// now we can execute the command, and catch all errors may be thrown
	TRY
		// NG_execute() can be used because HW220xTSR is installed
		NG_execute(CommandHandle, 0);
	ONERR
		// if an error is thrown, just display the error message
		ERD_dialog(errCode, FALSE);
	ENDTRY
	
	// free the command-handle
	HeapFree(CommandHandle);
};
